import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Asteroid here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Asteroid extends Actor
{
    private int size, speed= 4, health, maxHealth;
    private int damage = 1;
    //create first Asteroid
    public Asteroid()
    {
        this (50,20);
    }
    //Overloading the constructer; Creates all Asteroids.
    public Asteroid(int size, int maxHealth)
    {
        this.size = size;
        this.maxHealth = maxHealth;
        setRotation(Greenfoot.getRandomNumber(360));
        setState(size);
    }
    
    public void act() 
    {
       move(speed);
       worldWrapper();
       checkContact();
    }    
    
    public void setState(int size)
    {
        this.health = maxHealth;
        GreenfootImage thisImage = getImage();
        thisImage.scale(size,size);
    }
    
    //Getter/Acessor to return the current health of the Asteroid
    public int getHealth()
    {
        return health;
    }
    
    public int getDamage()
    {
        return damage;
    }
    
    //Check to see if the Asteroid has reached the edge of the screen and, if it has pop back out.
    public void worldWrapper()
    {
        if(getX() < 0)
        {
            setLocation(getWorld().getWidth(),getY());
        }
        else if(getX() > getWorld().getWidth())
        {
            setLocation(0,getY());
        }
        else if(getY() <0)
        {
            setLocation(getX(),getWorld().getHeight());
        }
        else if(getY()> getWorld().getHeight())
        {
            setLocation(getX(),0);
        }
        
    }
    
    public void checkContact()
    {
        //check if this asteroid is in contact with any projectiles and then take damage if it is
        if (isTouching(Projectile.class))
        {
            Projectile tempProjectile = (Projectile)getOneIntersectingObject(Projectile.class);
            health -= tempProjectile.getDamage();
            removeTouching(Projectile.class);
        }
        
        if (health >= maxHealth*.33 && health < maxHealth*.66)
        {
            changeTransparency(200);
        }
        else if (health > 0 && health < maxHealth*.33)
        {
            changeTransparency(100);
        }
        else if (health <=0)
        {
            spawnAsteroids();
            getWorld().removeObject(this);
        }
    }
        
    public void changeTransparency(int transparency)
    {
        GreenfootImage tempImage = getImage();
        tempImage.setTransparency(transparency);
    }
    
    public void spawnAsteroids()
    {
        if (size >=20)//splits the asteroid
        {
            for (int i = 0; i < 3; i++)
            {
                Asteroid newAsteroid = new Asteroid(size/2, maxHealth/2);
                getWorld().addObject(newAsteroid, getX(),getY());
            }
        }
        
    } 
}
