import greenfoot.*;

/**
 * Write a description of class Hero here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hero extends Actor
{
    private int speed_, health, maxHealth;
    private boolean triggerReleased;
    private int reloadTimerL, reloadTimerF, reloadTimerG;
    private final int RELOADL = 5, RELOADF = 50, RELOADG = 15;
    private boolean mouseIsDown = false;
    private int mouseState = 0;
    private GreenfootImage thisImage;
    
    private boolean dmgTaken = false;
    private boolean healTaken = false;
    private int dmgTakenTimer = 0;
    private int healTakenTimer = 0;
    public Hero()//constructor
    {
        speed_ = 5;
        maxHealth = 5;
        health = maxHealth;
        triggerReleased  = true;
        reloadTimerL = RELOADL;
        reloadTimerF = RELOADF;
        reloadTimerG = RELOADG;
        
        thisImage = new GreenfootImage("ship.png");
        thisImage.scale (50,50);
        setImage (thisImage);
    }
    
    public int getSpeed()//accessor getter
    {
        return speed_;
    }
    
    public void setSpeed(int s)//mutator setter
    {
        speed_ = s;
    }
    
    public int getHealth()
    {
        return health;
    }
    
    public void setHealth(int health)
    {
        this.health = health;
    }
    
    public double getStatus()
    {
        return (double)health/maxHealth;
    }
    
    
    public void act() 
    {
        // Add your action code here.
        processKeys();
        processShot();
        trackMouse();
        reloadTimerL--;
        reloadTimerF--;
        reloadTimerG--;
        checkContact();
        worldWrapper();
    }  
    
    public void processKeys()//move to assigned direction if key pressed
    {
        if(Greenfoot.isKeyDown("a"))
        {
            setLocation( getX() - speed_, getY() );
        }
        
        else if(Greenfoot.isKeyDown("d"))
        {
            setLocation( getX() + speed_, getY() );
        }
        
        if(Greenfoot.isKeyDown("w"))
        {
            setLocation( getX(), getY() - speed_ );
        }
        
        else if(Greenfoot.isKeyDown("s"))
        {
            setLocation( getX(), getY() + speed_ );
        }
        
    }
    
    public void processShot()
    {
        if(Greenfoot.isKeyDown("e") && reloadTimerF<=0)
        {
           shoot(new Missile(5));
           reloadTimerF = RELOADF;
           GreenfootSound sound= new GreenfootSound("missile.wav");
           sound.setVolume(50);//adjust the volume of the sound file.
           sound.play();//play the sound file when missile is fired.
        }
        else if(Greenfoot.isKeyDown("f")&& reloadTimerG<=0)
        {
           shoot(new Fireball(5));
           reloadTimerG = RELOADG;
        }
        else
        {
           triggerReleased = true;
        } 
    }
    
    public void shoot(Projectile fireThis)
    {
        if (triggerReleased)
        {
            fireThis.setRotation(getRotation());
            getWorld().addObject(fireThis, getX(), getY());
            fireThis.move(getImage() .getWidth()/2);
            triggerReleased = false;
        }
    }
    
    
    public void trackMouse()
    {
        MouseInfo mi = Greenfoot.getMouseInfo();
        if (mi !=null)
        {
            turnTowards(mi.getX(), mi.getY());
            if(Greenfoot.mousePressed(null))
            {
                mouseIsDown = true;
                if (mi.getButton() ==1)//shots
                {
                    mouseState = 1;
                }
            }
            else if(Greenfoot.mouseClicked(null))
            {
                mouseIsDown = false;
                mouseState = 0;
            }
            
            if(mouseIsDown)
            {
                if(mouseState ==1 && reloadTimerL <= 0)//if left mouse is clicked, laser will fire.
                {
                    shoot(new Laser(15));
                    reloadTimerL = RELOADL;
                }
                else
                {
                    mouseState=0;
                }
            }
        }
    }
    
    public void checkContact()
    {
        //check if asteroid is in contact with any projectiles and text damage if it is.
        if (isTouching(Asteroid.class) && dmgTaken == false)
        {
            Asteroid asteroid = (Asteroid) getOneIntersectingObject(Asteroid.class);
            health -= asteroid.getDamage();
            dmgTaken = true;
            dmgTakenTimer = 50;
            Greenfoot.playSound("CANNON1.wav");//play sound
        }
        //checks if hero is in contact with any heathPack then gain health.
        if (isTouching(HealthPack.class) && dmgTaken == false)
        {
            HealthPack tempHealthPack = (HealthPack) getOneIntersectingObject(HealthPack.class);
            health += tempHealthPack.getHeal();//gain health
            healTaken = true;
            healTakenTimer = 50;
        }
        
        if (dmgTaken == true)
        {
            dmgTakenTimer --; // dmgTakenTimer = dmgTakenTimer -1
            
            if (dmgTakenTimer <=0)
            {
                dmgTaken = false;
            }
        }
        
        if (health <=0)
        {
            /** ver0.1
             * If Space Ship's health is below 0, then the game ends
             * and ship will replaced to exploding image.
             * (Includes exploding sound)
             */
            setImage("explosion.png");
            GreenfootSound sound2 = new GreenfootSound("CANNON1.wav");
            sound2.play();
            // ver0.2- maintain the rotation of the image to upwards.
            setRotation(0);
            
            Greenfoot.setWorld(new RIP());
        }
    }
    
    public void worldWrapper()
    /**ver0.2- if spaceship touches to the edge of the world,
     * it will stop moving
     */ 
    {
        if(getX() < 0)
        {
            setLocation(0,getY());
        }
        else if(getX() > getWorld().getWidth())
        {
            setLocation(getWorld().getWidth(),getY());
        }
        else if(getY() <0)
        {
            setLocation(getX(),0);
        }
        else if(getY()> getWorld().getHeight())
        {
            setLocation(getX(),getWorld().getHeight());
        }
        
    }
}
